(************************************************)
(* 						*)
(*	  Tweaked 256 BGI driver defines	*)
(*		Copyright (c) 1991		*)
(*	    Jordan Hargraphix Software		*)
(*						*)
(************************************************)

type DacPalette256 = array[0..255] of array[0..2] of Byte;

(* Dies sind die zur Zeit untersttzten Modi *)
const
  TWK320x400x256	= 0;
  TWK320x480x256	= 1;
  TWK360x480x256	= 2;
  TWK376x564x256	= 3;
  TWK400x564x256	= 4;
  TWK400x600x256	= 5;

  XNOR_PUT		= 5;
  NOR_PUT		= 6;
  NAND_PUT		= 7;
  TRANS_COPY_PUT	= 8;	(* Doesn't work on 16-color systems *)

(* Setvgapalette setzt die komplette 256-Farben-Palette *)
(* PalBuf enthlt RGB-Werte fr alle 256 Farben         *)
(* R,G,B-Werte reichen von 0 bis 63                     *)
procedure SetVGAPalette256(PalBuf : DacPalette256);
var
  Reg : Registers;

begin
  reg.ax := $1012;
  reg.bx := 0;
  reg.cx := 256;
  reg.es := Seg(PalBuf);
  reg.dx := Ofs(PalBuf);
  intr($10,reg);
end;


