/************************************************/
/* 						*/
/*          SuperVGA BGI driver defines		*/
/*		Copyright (c) 1991		*/
/*	    Jordan Hargraphix Software		*/
/*						*/
/************************************************/

#include <dos.h>
#include "svga16.h"
#include "svga256.h"
#include "twk16.h"
#include "twk256.h"
#include "svga32k.h"

/* Getvgapalette16 holt die gesamte 16-Farben-Palette */
/* PalBuf enthlt RGB-Werte fr alle 16 Farben        */
/* R,G,B-Werte reichen von 0 bis 63	              */
/* Aufruf:                                            */
/*  DacPalette16 dac16;                               */
/*						      */
/*  getvgapalette(&dac16);			      */
void getvgapalette16(DacPalette16 *PalBuf)
{
  struct REGPACK reg;

  reg.r_ax = 0x1017;
  reg.r_bx = 0;
  reg.r_cx = 16;
  reg.r_es = FP_SEG(PalBuf);
  reg.r_dx = FP_OFF(PalBuf);
  intr(0x10,&reg);
}

/* Getvgapalette256 holt die gesamte 256-Farben-Palette */
/* PalBuf enthlt RGB-Werte fr alle 256 Farben         */
/* R,G,B-Werte reichen von 0 bis 63                     */
/* Aufruf:	                                        */
/*  DacPalette256 dac256;			        */
/*						        */
/* getvgapalette256(&dac256);			        */
void getvgapalette256(DacPalette256 *PalBuf)
{
  struct REGPACK reg;

  reg.r_ax = 0x1017;
  reg.r_bx = 0;
  reg.r_cx = 256;
  reg.r_es = FP_SEG(PalBuf);
  reg.r_dx = FP_OFF(PalBuf);
  intr(0x10,&reg);
}

/* Setvgapalette16 setzt die gesamte 16-Farben-Palette */
/* PalBuf enthlt RGB-Werte fr alle 16 Farben         */
/* R,G,B-Werte reichen von 0 bis 63	               */
/* Aufruf:                                             */
/*  DacPalette16 dac16;                                */
/*						       */
/*  setvgapalette(&dac16);			       */
void setvgapalette16(DacPalette16 *PalBuf)
{
  struct REGPACK reg;

  reg.r_ax = 0x1012;
  reg.r_bx = 0;
  reg.r_cx = 16;
  reg.r_es = FP_SEG(PalBuf);
  reg.r_dx = FP_OFF(PalBuf);
  intr(0x10,&reg);
}

/* Setvgapalette256 setzt die gesamte 256-Farben-Palette */
/* PalBuf enthlt RGB-Werte fr alle 256 Farben          */
/* R,G,B-Werte reichen von 0 bis 63                      */
/* Aufruf:	                                         */
/*  DacPalette256 dac256;			         */
/*						         */
/* setvgapalette256(&dac256);		                 */
void setvgapalette256(DacPalette256 *PalBuf)
{
  struct REGPACK reg;

  reg.r_ax = 0x1012;
  reg.r_bx = 0;
  reg.r_cx = 256;
  reg.r_es = FP_SEG(PalBuf);
  reg.r_dx = FP_OFF(PalBuf);
  intr(0x10,&reg);
}
