{Polarwolf Library V2.2}

Procedure CheckDate (Var Day, Month, Year : Word);
  Begin
    ToolsError := True;
    If Year < 100 Then Year := Year + Century * 100;
    If (Year < 1980) Or (Year > 2099) Then Exit;
    Feb29Exists := Year Mod 4 = 0;
    If (Month = 0) Or (Month > 12) Then Exit;
    If (Day = 0) Or (Day > MaxDays [Month]) And Not
       (Feb29Exists And (Month = 2) And (Day = 29)) Then Exit;
    ToolsError := False;
  End;

Procedure PackDate (Day, Month, Year : Word; Var P : Word);
  Var I : Word;
  Begin
    P := 0;
    CheckDate (Day, Month, Year);
    If ToolsError Then Exit;
    Year := Year - 1980;
    P := Day - 1;
    P := P + DaySum [Month];
    If Feb29Exists And (Month > 2) Then Inc (P);
    If Year > 0  Then
      For I := 0 To Year -1 Do P := P + YearDays [I Mod 4]
  End;

Procedure UnPackDate (P : Word; Var Day, Month, Year : Word);
  Var I : Word;
  Begin
    ToolsError := False;
    Day := 0;
    Month := 0;
    Year  := 0;
    While P >= YearDays [Year Mod 4] Do
      Begin
        P := P - YearDays [Year Mod 4];
        Inc (Year)
      End;
    Year := Year + 1980;
    Feb29Exists := Year Mod 4 = 0;
    For I := 1 To 12 Do
      If (P >= DaySum [I]) And
        Not ((I = 3) And (P = DaySum [3]) And Feb29Exists)
        Then Month := I;
    Day := P - DaySum [Month] + 1;
    If Feb29Exists And (Month > 2) Then Dec (Day)
  End;

Procedure StrDate (P : Word; Var S : String);
  Var Hilf : String;
      Day, Month, Year : Word;
  Begin
    ToolsError := False;
    S := '';
    UnPackDate (P, Day, Month, Year);
    Str (Day : 2, Hilf);
    S := Hilf + '.';
    Str (Month : 2, Hilf);
    S := S + Hilf + '.';
    Str (Year : 4, Hilf);
    S := S + Hilf
  End;

Procedure ValDate (S : String; Var P : Word);
  Var Day, Month, Year : Word;
      DayStr, MonthStr, YearStr : String[6];
      Test : Integer;
  Begin
    ToolsError := True;
    P := 0;
    If Length (S) > 10 Then Exit;
    If (Pos ('e', S) > 0) Or (Pos ('E', S) > 0) Then Exit;
    If Pos ('-', S) > 0 Then Exit;
    If Not (Pos ('.', S) In [2,3]) Then Exit;
    DayStr := Copy (S, 1, Pos ('.', S)-1);
    Delete (S, 1, Pos ('.', S));
    If Not (Pos ('.', S) In [2,3]) Then Exit;
    MonthStr := Copy (S, 1, Pos ('.', S)-1);
    Delete (S, 1, Pos ('.', S));
    YearStr := S;
    Val (DayStr, Day, Test);
    If Test > 0 Then Exit;
    Val (MonthStr, Month, Test);
    If Test > 0 Then Exit;
    Val (YearStr, Year, Test);
    If Test > 0 Then Exit;
    PackDate (Day, Month, Year, P)
  End;

Function DayOfWeek (P : Word) : String;
  Const MSG : Array [0..6] Of String [10]= ('Dienstag', 'Mittwoch',
              'Donnerstag', 'Freitag', 'Samstag', 'Sonntag', 'Montag');
  Begin
    ToolsError := False;
    DayOfWeek := MSG [P Mod 7]
  End;

Function Today : Word;
  Var Day, Month, Year, DayOfWeek, H : Word;
  Begin
    GetDate (Year, Month, Day, DayOfWeek);
    PackDate (Day, Month, Year, H);
    Today := H
  End;
