{Polarwolf Library V2.2}

Procedure DefineInputParam (IP: TInputParam; Name : TIPName);
  Var I : Byte;
      H : PParamWithName;
  Begin
    AdditionalInputEnd := '';
    For I := 1 To Length (Name) Do Name [I] := UpcaseGr (Name [I]);
    New (H);
    H^.IP := IP;
    H^.Name := Name;
    H^.Next := FirstParam;
    FirstParam := H
  End;

Procedure SetInputParam (Name : TIPName);
  Var I : Byte;
      H : PParamWithName;
  Begin
    ToolsError := False;
    For I := 1 To Length (Name) Do Name [I] := UpcaseGr (Name [I]);
    H := FirstParam;
    While H <> Nil Do
      Begin
        If H^.Name = Name Then
          Begin
            GlobalIP := H^.IP;
            Exit
          End;
        H := H^.Next
      End;
    ToolsError := True
  End;

Procedure FindFieldViaHandle (Handle : Byte; Var Field : PField);
  Var I : Byte;
  Begin
    Field := FirstField;
    For I := 1 To Handle Do
      If Field <> Nil Then Field := Field^.Next
  End;

Procedure FindField (X, Y: Byte; Var Field : PField);
  Begin
    If X = 0 Then
      Begin
        FindFieldViaHandle (Y, Field);
        Exit
      End;
    Field := FirstField;
    While Field <> Nil Do
      Begin
        If (Field^.X = X) And (Field^.Y = Y) Then Exit;
        Field := Field^.Next
      End
  End;

Procedure SetField (X, Y : Byte; Name : TIPName; Input : Pointer);
  Var H, L : PField;
  Begin
    FindField (X, Y, H);
    If H = Nil Then
      Begin
        L := FirstField;
        If L <> Nil Then While L^.Next <> Nil Do L := L^.Next;
        New (H);
        H^.Next := Nil;
        H^.X := X;
        H^.Y := Y;
        If FirstField = Nil Then FirstField := H Else L^.Next := H;
      End;
    H^.Name := Name;
    H^.Input := Input
  End;

Procedure ClearField (X, Y : Byte);
  Var H : PField;
      Source : ^PField;
  Begin
    ToolsError := False;
    H := FirstField;
    Source := @FirstField;
    While H <> Nil Do
      Begin
        If (H^.X = X) And (H^.Y = Y) Then
          Begin
            Source^ := H^.Next;
            Dispose (H);
            Exit
          End;
        Source := @H^.Next;
        H := H^.Next
      End;
    ToolsError := True
  End;

Procedure RemoveAllFields;
  Var H : PField;
  Begin
    While FirstField <> Nil Do
      Begin
        H := FirstField^.Next;
        Dispose (FirstField);
        FirstField := H
      End
  End;

Procedure PrepareEdit;
  Var Best : Byte;
      H, P, BestPtr : PField;
  Begin
    If Not CopyRightRequested Then RunError;
    H := FirstField;
    While H <> Nil Do
      Begin
        Best := 0; {Up}
        BestPtr := Nil;
        P := FirstField;
        While P <> Nil Do
          Begin
            If (P^.X = H^.X) And (P^.Y < H^.Y) And (P^.Y > Best) Then
              Begin
                Best := P^.Y;
                BestPtr := P
              End;
            P := P^.Next
          End;
        H^.Up := BestPtr;
        Best := 255; {Down}
        BestPtr := Nil;
        P := FirstField;
        While P <> Nil Do
          Begin
            If (P^.X = H^.X) And (P^.Y > H^.Y) And (P^.Y < Best) Then
              Begin
                Best := P^.Y;
                BestPtr := P
              End;
            P := P^.Next
          End;
        H^.Down := BestPtr;
        Best := 0; {Left}
        BestPtr := Nil;
        P := FirstField;
        While P <> Nil Do
          Begin
            If (P^.Y = H^.Y) And (P^.X < H^.X) And (P^.X > Best) Then
              Begin
                Best := P^.Y;
                BestPtr := P
              End;
            P := P^.Next
          End;
        H^.Left := BestPtr;
        Best := 255; {Right}
        BestPtr := Nil;
        P := FirstField;
        While P <> Nil Do
          Begin
            If (P^.Y = H^.Y) And (P^.X > H^.X) And (P^.X < Best) Then
              Begin
                Best := P^.Y;
                BestPtr := P
              End;
            P := P^.Next
          End;
        H^.Right := BestPtr;
        H := H^.Next
      End;
    EditField := FirstField;
    EditChar := Nul
  End;

Procedure ConnectFields (X1, Y1, X2, Y2, Dirction1, Direction2 : Byte);
  Var H1, H2 : PField;
  Begin
    FindField (X1, Y1, H1);
    If ToolsError Then Exit;
    FindField (X2, Y2, H2);
    If ToolsError Then Exit;
    Case Dirction1 Of
        ConnectUp    : H1^.Up := H2;
        ConnectDown  : H1^.Down := H2;
        ConnectLeft  : H1^.Left := H2;
        ConnectRight : H1^.Right := H2;
      End;
    Case Direction2 Of
        ConnectUp    : H2^.Up := H1;
        ConnectDown  : H2^.Down := H1;
        ConnectLeft  : H2^.Left := H1;
        ConnectRight : H2^.Right := H1;
      End
  End;

Procedure DeleteFieldConnection (X, Y, Direction: Byte);
  Var H : PField;
  Begin
    FindField (X, Y, H);
    If ToolsError Then Exit;
    Case Direction Of
        ConnectUp    : H^.Up := Nil;
        ConnectDown  : H^.Down := Nil;
        ConnectLeft  : H^.Left := Nil;
        ConnectRight : H^.Right := Nil;
      End
  End;

Procedure SetEditPos (X, Y : Byte);
  Begin
    FindField (X, Y, EditField)
  End;

Procedure PrintEdit;
  Var H : PField;
  Begin
    SetStdColor;
    H := FirstField;
    While H <> Nil Do
      Begin
        SetInputParam (H^.Name);
        GotoXY (H^.X, H^.Y);
        PrintInput (H^.Input^);
        H := H^.Next
      End
  End;

Procedure DoEdit;
  Var H : PField;
  Begin
    ToolsError := False;
    Repeat
      If (EditChar = Up   ) And (EditField^.Up    <> Nil) Then EditField := EditField^.Up;
      If (EditChar = Down ) And (EditField^.Down  <> Nil) Then EditField := EditField^.Down;
      If (EditChar = Left ) And (EditField^.Left  <> Nil) Then EditField := EditField^.Left;
      If (EditChar = Right) And (EditField^.Right <> Nil) Then EditField := EditField^.Right;
      If EditChar = Cr Then If EditField^.Next <> Nil Then
        EditField := EditField^.Next Else EditField := FirstField;
      If EditField = Nil Then
        Begin
          ToolsError := True;
          Exit
        End;
      SetInputParam (EditField^.Name);
      GlobalIP.IEnd := InterruptEdit;
      If EditField^.Up <> Nil Then
        GlobalIP.IEnd := GlobalIP.IEnd + Up;
      If EditField^.Down <> Nil Then
        GlobalIP.IEnd := GlobalIP.IEnd + Down;
      If EditField^.Left <> Nil Then
        GlobalIP.IEnd := GlobalIP.IEnd + Left;
      If EditField^.Right <> Nil Then
        GlobalIP.IEnd := GlobalIP.IEnd + Right;
      GotoXY (EditField^.X, EditField^.Y);
      DoInput (EditField^.Input^);
      EditChar := InputEndChar;
    Until (Pos (EditChar, InterruptEdit) > 0) Or KbdEsc
  End;

Function GetEditX : Byte;
  Begin
    If EditField <> Nil Then GetEditX := EditField^.X Else GetEditX := 0
  End;

Function GetEditY : Byte;
  Begin
    If EditField <> Nil Then GetEditY := EditField^.Y Else GetEditY := 0
  End;

Function GetEditHandle (X, Y : Byte) : Byte;
  Var I : Byte;
      Field : PField;
  Begin
    GetEditHandle := 0;
    Field := FirstField;
    I := 1;
    While Field <> Nil Do
      Begin
        If (Field^.X = X) And (Field^.Y = Y) Then GetEditHandle := I;
        Field := Field^.Next;
        Inc (I)
      End
  End;

