{Polarwolf Library V2.2}

Function NrOfIcons2 : Byte;
  Begin
    NrOfIcons2 := IconField^[1]
  End;

Function FindIcon (Name : TIPName) : Byte;
  Var IconNameP : ^TIPName;
      F, I : Byte;
  Begin
    F := 255;
    For I := 1 To Length (Name) Do Name [I] := UpCaseGr (Name [I]);
    For I := 0 To NrOfIcons2-1 Do
      Begin
        IconNameP := @IconField^ [I *24 +10];
        If IconNameP^ = Name Then F := I
      End;
    ToolsError := F = 255;
    FindIcon := F
  End;

Procedure ChangeIconModeByNr (Nr, Modus : Byte);
  Var V1, V2, V3 : Word;
  Begin
    V1 := IconField^ [Nr *24 +2] * 256 + IconField^ [Nr *24 +3];
    V2 := IconField^ [Nr *24 +4] * 256 + IconField^ [Nr *24 +5];
    V3 := IconField^ [Nr *24 +8] * 256 +
                     IconField^ [Nr *24 +9]       +
                     NrOfIcons2 * 24 +1;
    PutImage (V1, V2, IconField^[V3], Modus);
  End;

Procedure SetIcon (Name : TIPName);
  Var Nr : Byte;
  Begin
    Nr := FindIcon (Name);
    If ToolsError Then Exit;
    ChangeIconModeByNr (Nr, NormalPut);
    IconMode [Nr] := IconOn
  End;

Procedure InvertIcon (Name : TIPName);
  Var Nr : Byte;
  Begin
    Nr := FindIcon ('$' + Name);
    If ToolsError Then
      Begin
        Nr := FindIcon (Name);
        If ToolsError Then Exit;
        If IconMode [Nr] = IconOn Then ChangeIconModeByNr (Nr, XOrPut);
        ChangeIconModeByNr (Nr, NotPut);
        IconMode [Nr] := IconInvers
      End
      Else Begin
        ChangeIconModeByNr (Nr, NormalPut);
        Nr := FindIcon (Name);
        IconMode [Nr] := IconInvers
      End;
  End;

Procedure DeleteIcon (Name : TIPName);
  Var Nr, Nr2 : Byte;
  Begin
    Nr := FindIcon ('$' + Name);
    If ToolsError Then
      Begin
        Nr := FindIcon (Name);
        If ToolsError Then Exit;
        If IconMode [Nr] = IconOff Then Exit;
        If IconMode [Nr] = IconInvers Then ChangeIconModeByNr (Nr, NormalPut);
        ChangeIconModeByNr (Nr, XOrPut);
        IconMode [Nr] := IconOff
      End
      Else Begin
        Nr2 := FindIcon (Name);
        If IconMode [Nr2] = IconOff Then Exit;
        If IconMode [Nr2] = IconOn Then Nr := Nr2;
        ChangeIconModeByNr (Nr, XOrPut)
      End;
  End;

Procedure RemoveAllIcons;
  Var I : Byte;
  Begin
    For I := 0 To NrOfIcons2 -1 Do
      Begin
        If IconMode [I] = IconInvers Then ChangeIconModeByNr (I, NormalPut);
        If IconMode [I] <> IconOff Then ChangeIconModeByNr (I, XOrPut);
        IconMode [I] := IconOff
      End
  End;

Function GetIconState (Name : TIPName) : Byte;
  Var Nr : Byte;
  Begin
    Nr := FindIcon (Name);
    If ToolsError Then Exit;
    GetIconState := IconMode [Nr]
  End;

Procedure ChangeIconPosition (Name : TIPName; XNew, YNew : Word);
  Var Nr : Byte;
  Begin
    Nr := FindIcon (Name);
    If ToolsError Then Exit;
    If IconMode [Nr] = IconInvers Then ChangeIconModeByNr (Nr, NormalPut);
    If IconMode [Nr] <> IconOff Then ChangeIconModeByNr (Nr, XOrPut);
    IconField^ [Nr *24 +2] := Hi (XNew);
    IconField^ [Nr *24 +3] := Lo (XNew);
    IconField^ [Nr *24 +4] := Hi (YNew);
    IconField^ [Nr *24 +5] := Lo (YNew);
    If IconMode [Nr] = IconOn Then ChangeIconModeByNr (Nr, NormalPut);
    If IconMode [Nr] = IconInvers Then ChangeIconModeByNr (Nr, NotPut)
  End;

Procedure SetIconProc (Name : TIPName; IconProcedure : TIconProc);
  Var Nr : Byte;
  Begin
    Nr := FindIcon (Name);
    If ToolsError Then Exit;
    IconProc [Nr] := IconProcedure
  End;

Procedure DoIcon;
  Var MouseX, MouseY : Integer;
      I : Byte;
  Begin
    IconCalled := False;
    GetMousePosition (MouseX, MouseY);
    For I := 0 To NrOfIcons2 -1 Do
      Begin
        If (MouseX >= IconField^ [I *24 +2] * 256 + IconField^ [I *24 +3]) And
           (MouseY >= IconField^ [I *24 +4] * 256 + IconField^ [I *24 +5]) And
           (MouseX <  IconField^ [I *24 +2] * 256 + IconField^ [I *24 +3] +
                     IconField^ [I *24 +6]) And
           (MouseY <  IconField^ [I *24 +4] * 256 + IconField^ [I *24 +5] +
                     IconField^ [I *24 +7]) And
           (IconMode [I] > IconOff) Then
             Begin
               IconProc [I];
               IconCalled := True
             End
      End
  End;

Function RegisterIconField (IconPointer : Pointer) : Integer;
  Begin
    If IconFieldOnHeap Then Dispose (IconField);
    IconFieldOnHeap := False;
    IconField := IconPointer;
    RegisterIconField := 0
  End;

{$I-}
Procedure ReadIconField (FileName : String);
  Var FileVar : File;
      I,S : Word;
  Begin
    ToolsError := False;
    If IconFieldOnHeap Then Dispose (IconField);
    IconFieldOnHeap := True;
    Assign (FileVar, FileName);
    ReSet (FileVar, 1);
    If IOResult > 1 Then ToolsError := True;
    S := FileSize (FileVar);
    Close (FileVar);
    If IOResult > 1 Then ToolsError := True;
    GetMem (IconField, S);
    Assign (FileVar, FileName);
    ReSet (FileVar, S);
    If IOResult > 1 Then ToolsError := True;
    BlockRead (FileVar, IconField^, 1);
    If IOResult > 1 Then ToolsError := True;
    Close (FileVar);
    If IOResult > 1 Then ToolsError := True;
    For I := 1 To MaxIcons Do IconMode [I] := IconOff;
  End;

{$F+}
Procedure Dummy;
  Begin
  End;
{$F-}
