{Polarwolf Library V2.2}

Procedure PrintInputString (X, Y : Byte; S : String);
  Begin
    HideCursor;
    GotoXY (X, Y);
    Write (S);
    While WhereX < X + GlobalIP.ILen Do Write (Space);
    If Length (S) = GlobalIP.ILen Then
      Begin
        GotoXY (X + GlobalIP.ILen-1, Y);
        ShowAlternateCursor
      End
      Else Begin
        GotoXY (X + Length (S), Y);
        ShowCursor
      End
  End;

Procedure DoBS (Var S : String);
  Begin
    If S = '' Then
      Begin
        Play (Beep);
        Exit
      End;
    InputChanged := True;
    Delete (S, Length (S), 1)
  End;

Procedure DoPoint (Var S : String; WithSign : Boolean);
  Begin
    If Not InputChanged Then S := '';
    If (Pos (',', S) > 0) Or (Length (S) > GlobalIP.ILen -2)
      Then Begin
        Play (Beep);
        Exit
      End;
    InputChanged := True;
    If S = '' Then
      If WithSign Then
        S := '+0'
        Else S := '0'
      Else Begin End;
    If WithSign And (Length (S) =1) Then
      S := S + '0';
    S := S + ','
  End;

Procedure DoChar (Ch : Char; Var S : String; WithSign: Boolean);
  Begin
    If Not InputChanged Then S := '';
    If Length (S) = GlobalIP.ILen Then
      Begin
        Play (Beep);
        Exit
      End;
    InputChanged := True;
    If (Pos (Ch, '0123456789') > 0) And WithSign And (S = '') Then S := '+';
    S := S + Ch
  End;

Procedure CharInput (Var P; Mode: Boolean);
  Var X, Y : Byte;
      Ch : Char;
      A : ASCII;
  Begin
    Ch := Char (P);
    If Not Mode Then
      Begin
        SetStdColor;
        Write (Ch);
        Exit
      End;
    X := WhereX;
    Y := WhereY;
    Write (Ch);
    GotoXY (X, Y);
    GetAllowed := GlobalIP.IAllowed + Cr;
    ShowCursor;
    GetKey (A);
    If KbdESC Then Exit;
    If Not A.Scan And (A.Ch <> Cr) Then
      Begin
        Ch := A.Ch;
        InputChanged := True
      End
      Else InputEndChar := A.Ch;
    If InputChanged Then Char (P) := Ch;
    CharInput (P, PrintOnly)
  End;

Procedure StringInput (Var P; Mode : Boolean);
  Var X, Y : Byte;
      A : ASCII;
      S : String;
  Begin
    S := String (P);
    X := WhereX;
    Y := WhereY;
    If Not Mode Then
      Begin
        SetStdColor;
        PrintInputString (X, Y, S);
        Exit
      End;
    GetAllowed := GlobalIP.IAllowed + Cr + BS;
    Repeat
      PrintInputString (X, Y, S);
      GetKey (A);
      If KbdEsc Then Exit;
      If (Not A.Scan) And (A.Ch = BS) Then DoBS (S);
      If (Not A.Scan) And (A.Ch >= Space) Then DoChar (A.Ch, S, False)
    Until A.Scan Or (A.Ch = CR);
    If A.Scan Or (A.Ch < Space) Then InputEndChar := A.Ch;
    If InputChanged Then String (P) := S;
    GotoXY (X, Y);
    StringInput (P, PrintOnly)
  End;

Procedure IntegerInput (Var P; Mode: Boolean);
  Var WithSign : Boolean;
      X, Y : Byte;
      It, HI : Integer;
      A : ASCII;
      S, HS : String;
  Begin
    It := Integer (P);
    X := WhereX;
    Y := WhereY;
    If GlobalIP.IntMin > GlobalIP.IntMax Then
      Begin
        HI := GlobalIP.IntMin;
        GlobalIP.IntMin := GlobalIP.IntMax;
        GlobalIP.IntMax := HI
      End;
    If Abs (GlobalIP.IntMax) > Abs (GlobalIP.IntMin) Then
      HI := Abs (GlobalIP.IntMax) Else HI := Abs (GlobalIP.IntMin);
    Case HI Of
           0 ..    9 : GlobalIP.ILen := 1;
          10 ..   99 : GlobalIP.ILen := 2;
         100 ..  999 : GlobalIP.ILen := 3;
        1000 .. 9999 : GlobalIP.ILen := 4
      Else GlobalIP.ILen := 5
      End;
    WithSign := (GlobalIP.IntMin < 0) And (GlobalIP.IntMax >= 0);
    If WithSign Then Inc (GlobalIP.ILen);
    If Not Mode Then
      Begin
        SetStdColor;
        Write (It : GlobalIP.ILen);
        Exit
      End;
    Str (It, S);
    If WithSign And (It > -1) Then
      S := '+' + S;
    GetAllowed := '1234567890' + BS + CR;
    If WithSign Then GetAllowed := GetAllowed + '+-';
    Repeat
      Repeat
        PrintInputString (X, Y, S);
        GetKey (A);
        If KbdEsc Then Exit;
        If Not A.Scan Then
          Case A.Ch Of
              BS       : DoBS (S);
              '+', '-' : If (S = '') Or Not InputChanged Then
                           DoChar (A.Ch, S, WithSign) Else Play (Beep);
              '0'..'9' : DoChar (A.Ch, S, WithSign)
            End
      Until A.Scan Or (A.Ch = CR);
      HS := S;
      If HS = '' Then If WithSign Then HS := '+0' Else HS := '0'
        Else Begin End;
      If (HS = '+') Or (HS = '-') Then HS := HS + '1';
      Val (HS, It, HI);
      If (It < GlobalIP.IntMin) Or (It > GlobalIP.IntMax)
        Then Play (Beep)
    Until (It >= GlobalIP.IntMin) And (It <= GlobalIP.IntMax);
    If A.Scan Or (A.Ch < Space)Then InputEndChar := A.Ch;
    If InputChanged Then Integer (P) := It;
    GotoXY (X, Y);
    IntegerInput (P, PrintOnly)
   End;

Procedure RealInput (Var P; Mode : Boolean);
  Var WithSign : Boolean;
      X, Y : Byte;
      R, HR : Real;
      S, HS : String;
      A : ASCII;
      HI : Integer;
  Begin
    R := Real (P);
    X := WhereX;
    Y := WhereY;
    If GlobalIP.RealMin > GlobalIP.RealMax Then
      Begin
        HR := GlobalIP.RealMin;
        GlobalIP.RealMin := GlobalIP.RealMax;
        GlobalIP.RealMax := HR
      End;
    WithSign := (GlobalIP.RealMin < 0) And (GlobalIP.RealMax >= 0);
    Str (R : 0 : GlobalIP.ILen, S);
    If WithSign And (R >= 0) Then S := '+' + S;
    If Pos ('.', S) > 0 Then S [Pos ( '.', S)] := ',';
    S := Copy (S, 1, GlobalIP.ILen);
    While (Pos (S [Length (S)], ',0') > 0) And
          (Pos (',', S) > 0) Do Delete (S, Length (S), 1);
    If Not Mode Then
      Begin
        SetStdColor;
        Write (S : GlobalIP.ILen);
        Exit
      End;
    GetAllowed := '1234567890.,' + BS + CR;
    If WithSign Then GetAllowed := GetAllowed + '+-';
    Repeat
      Repeat
        PrintInputString (X, Y, S);
        GetKey (A);
        If KbdEsc Then Exit;
        If Not A.Scan Then
          Case A.Ch Of
              BS       : DoBs (S);
              '.', ',' : DoPoint (S, WithSign);
              '+', '-' : If (S = '') Or Not InputChanged Then
                           DoChar (A.Ch, S, WithSign) Else Play (Beep);
              '0'..'9' : DoChar (A.Ch, S, WithSign)
          End
      Until A.Scan Or (A.Ch = CR);
      HS := S;
      If HS = '' Then If WithSign Then
        HS := '+0' Else HS := '0' Else Begin End;
      If (HS = '+') Or (HS = '-') Then
        HS := HS + '1';
      If HS [Length (HS)] = ',' Then
        Delete (HS, Length (HS), 1);
      If Pos(',', HS) > 0 Then HS[Pos(',',HS)]:= '.';
      Val (HS, R, HI);
      If (R < R) Or (R > GlobalIP.RealMax) Then Play (Beep);
      If Pos('.', HS) >0 Then HS [Pos ('.', HS)] := ','
    Until (R >= GlobalIP.RealMin) And (R <= GlobalIP.RealMax);
    If A.Scan Or (A.Ch < Space) Then InputEndChar := A.Ch;
    If InputChanged Then Real (P) := R;
    GotoXY (X, Y);
    RealInput (P, PrintOnly);
  End;

Procedure YesNoInput (Var P; Mode : Boolean);
  Const YesNo : Array [False..True] Of String[4] = ('Nein',' Ja ');
  Var YN : Boolean;
      X, Y : Byte;
      A : ASCII;
  Begin
    YN := Boolean (P);
    X := WhereX;
    Y := WhereY;
    If Not Mode Then
      Begin
        SetStdColor;
        Write (YesNo [YN]);
        Exit
      End;
    Write (YesNo [YN]);
    GotoXY (X, Y);
    GetAllowed := Cr + 'jnJN';
    GetKey (A);
    If KbdESC Then Exit;
    If Not A.Scan And (A.Ch <> Cr) Then
      Begin
        If UpCase (A.Ch)= 'J' Then YN := True
          Else YN := False;
        InputChanged := True
      End
      Else InputEndChar := A.Ch;
    If InputChanged Then Boolean (P) := YN;
    YesNoInput (P, PrintOnly)
  End;

Procedure DateInput (Var P; Mode : Boolean);
  Var D : Word;
      X, Y : Byte;
      A : ASCII;
      S : String;
  Begin
    D := Word (P);
    X := WhereX;
    Y := WhereY;
    GlobalIP.ILen := 10;
    StrDate (D, S);
    If Not Mode Then
      Begin
        SetStdColor;
        Write (S);
        Exit
      End;
    GetAllowed := '1234567890.,' + Cr + BS;
    Repeat
      Repeat
        PrintInputString (X, Y, S);
        GetKey (A);
        If KbdEsc Then Exit;
        If Not A.Scan And (A.Ch = ',') Then A.Ch := '.';
        If (Not A.Scan) And (A.Ch = BS) Then DoBS (S);
        If (Not A.Scan) And (A.Ch >= Space) Then
          DoChar (A.Ch, S, False)
      Until A.Scan Or (A.Ch = CR);
      ValDate (S, D);
      If ToolsError Then Play (Beep);
    Until Not ToolsError;
    If A.Scan Or (A.Ch < Space) Then InputEndChar := A.Ch;
    If InputChanged Then Word (P) := D;
    GotoXY (X, Y);
    DateInput (P, PrintOnly)
  End;

Procedure CurrentInput (Var P; Mode: Boolean);
  Var X, Y, B : Byte;
      It : LongInt;
      Test : Integer;
      A : ASCII;
      S, HS : String;
  Begin
    It := LongInt (P);
    X := WhereX;
    Y := WhereY;
    Str (It Div 100, S);
    Str (It Mod 100, HS);
    If Length (HS) = 1 Then HS := '0' + HS;
    S := S + '.' + HS;
    If Length (S) > GlobalIP.ILen Then
      Begin
        S := '';
        For B := 1 To GlobalIP.ILen Do S := S + '#'
      End;
    If Not Mode Then
      Begin
        SetStdColor;
        If Length (S) <= GlobalIP.ILen Then
          Write (S : GlobalIP.ILen)
          Else For X := 1 To GlobalIP.ILen Do Write ('#');
        Exit
      End;
    GetAllowed := '1234567890.,' + BS + CR;
    Repeat
      PrintInputString (X, Y, S);
      GetKey (A);
      If KbdEsc Then Exit;
      If Not A.Scan And (A.Ch = ',') Then A.Ch := '.';
      If Not A.Scan Then
        Case A.Ch Of
            BS       : DoBS (S);
            '.'      : Begin
                         If Not InputChanged Then S := '';
                         If Length (S) = GlobalIP.ILen Then Play (Beep)
                         Else Begin
                           InputChanged := True;
                            S := S + '.'
                         End
                       End;
            '0'..'9' : If (Pos ('.', S) = 0) Or (Pos ('.', S) > Length (S) -2)
                         Or Not InputChanged
                         Then DoChar (A.Ch, S, False) Else Play (Beep)
          End
    Until A.Scan Or (A.Ch = CR);
    If S = '' Then S := '0';
    If Pos ('.', S) > 0 Then
      Begin
        HS := Copy (S, 1, Pos ('.', S) -1);
        If Pos ('.', S) < Length (S) Then S := Copy (S, Pos ('.', S) +1, 99)
          Else S := '0';
        Val (HS, It, Test);
        Val (S, B, Test);
        If Length (S) = 1 Then B := B * 10;
        It := 100 * IT + B
      End
      Else Begin
        Val (S, It, Test);
        It := 100 * It
      End;
    If A.Scan Or (A.Ch < Space)Then InputEndChar := A.Ch;
    If InputChanged Then LongInt (P) := It;
    GotoXY (X, Y);
    CurrentInput (P, PrintOnly)
   End;

Procedure PrintInput (Var Input);
  Begin
    GlobalIP.InputProc (Input, PrintOnly)
  End;

Procedure DoInput (Var Input);
  Begin
    InputChanged := False;
    InputEndChar := Nul;
    CapsOnly := GlobalIP.ConvertToCaps;
    GetScanAllowed := GlobalIP.IEnd + AdditionalInputEnd;
    HideCursor;
    SetStdInvColor;
    GlobalIP.InputProc (Input, PrintAndInput);
    SetStdColor;
    HideCursor
  End;
