{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{
*                                                                         *
*                         Polarwolf Library V 2.2                         *
*                                                                         *
*    (C) Barbara Tikart  Polarwolf Hard & Software, Erlenbach am Main     *
*                                                                         *
*    Diese Toolbox ist Shareware!                                         *
*                                                                         *
*    Bitte lesen Sie die Lizenzbedingungen (LIZENZ.DOC)                   *
*                                                                         *
*                                                                         *
}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}

Unit PWLib;

{$A+,B-,E-,F-,G-,I-,L-,N-,O-,R-,S+,V+,X+}

Interface

Type String6 = String[6];

Const Nul        =  #0;   Break      =  #3;   Bell       =  #7;
      BS         =  #8;   HT         =  #9;   LF         = #10;
      VT         = #11;   FF         = #12;   CR         = #13;
      SO         = #14;   SI         = #15;   CAN        = #24;
      EOI        = #26;   ESC        = #27;   Space      = #32;

      F1  = #59; ShiftF1  = #84; CtrlF1  = #94; AltF1  =#104;
      F2  = #60; ShiftF2  = #85; CtrlF2  = #95; AltF2  =#105;
      F3  = #61; ShiftF3  = #86; CtrlF3  = #96; AltF3  =#106;
      F4  = #62; ShiftF4  = #87; CtrlF4  = #97; AltF4  =#107;
      F5  = #63; ShiftF5  = #88; CtrlF5  = #98; AltF5  =#108;
      F6  = #64; ShiftF6  = #89; CtrlF6  = #99; AltF6  =#109;
      F7  = #65; ShiftF7  = #90; CtrlF7  =#100; AltF7  =#110;
      F8  = #66; ShiftF8  = #91; CtrlF8  =#101; AltF8  =#111;
      F9  = #67; ShiftF9  = #92; CtrlF9  =#102; AltF9  =#112;
      F10 = #68; ShiftF10 = #93; CtrlF10 =#103; AltF10 =#113;

      Home  = #71; CtrlHome  = #119;
      Up    = #72;
      PgUp  = #73; CtrlPgUp  = #132;
      Left  = #75; CtrlLeft  = #115;
      Num5  = #76;
      Right = #77; CtrlRight = #116;
      Ende  = #79; CtrlEnde  = #117;
      Down  = #80;
      PgDn  = #81; CtrlPgDn  = #118;

      Ins = #82; Del = #83; Tab =  #9; ShiftTab = #15;

      AltA = #30; AltB = #48; AltC = #46; AltD = #32; AltE = #18;
      AltF = #33; AltG = #34; AltH = #35; AltI = #23; AltJ = #36;
      AltK = #37; AltL = #38; AltM = #50; AltN = #49; AltO = #24;
      AltP = #25; AltQ = #16; AltR = #19; AltS = #31; AltT = #20;
      AltU = #22; AltV = #47; AltW = #17; AltX = #45; AltY = #21;
      AltZ = #44;

      Alt1 = #120; Alt2 = #121; Alt3 = #122; Alt4 = #123; Alt5 = #124;
      Alt6 = #125; Alt7 = #126; Alt8 = #127; Alt9 = #128; Alt0 = #129;

      CtrlMinus = #31; AltMinus = #53; AltNumMinus = #74;
      CtrlPlus  = #29; AltPlus  = #27; AltNumPlus  = #78;
      CtrlNumAst =  #42; AltNumAst = #55;

      CtrlDoubleCross = #28; AltDoubleCross  = #43;
      AltApostrophe =  #131; AltQuestionMark = #130;
      Ctrl6 = #30; AltComma = #51; AltPoint = #52;

      CtrlBS = #127; AltBS = #14; AltCr = #28;

      Invers    = 1; Light     = 2;  Underline = 4;

      AllVisibleChar : String = '';
      AllASCIICodes  : String = '';
                                        {AT Only:}
      RightShiftKey =   1;      LeftCtrlKey       =   256;
      LeftShiftKey  =   2;      LeftAltKey        =   512;
      CtrlKey       =   4;      RightCtrlKey      =  1024;
      AltKey        =   8;      RightAltKey       =  2048;
      ScrollLock    =  16;      ScrollLockPressed =  4096;
      NumLock       =  32;      NumLockPressed    =  8192;
      CapsLock      =  64;      CapsLockPressed   = 16384;
      InsertMode    = 128;      SysRqPressed      = 32768;

      XT = False;               AT = True;
      PrintOnly = False;        PrintAndInput = True;
      ConnectUp = 1; ConnectDown = 2; ConnectLeft = 3; ConnectRight = 4;

      Beep : Array [0..2] Of Word = (165, 900, 0);

      TinyLine   : String6 = '-|||||';
      SingleLine : String6 = 'ĳڿ';
      DoubleLine : String6 = 'ͺɻȼ';

     PRBold         = #27#69;       PRBoldOff      = #27#70;
     PRItalic       = #27#4;        PRItalicOff    = #27#5;
     PRUnderline    = #27#45#1;     PRUnderlineOff = #27#45#0;
     PRCondensed    = #15;          PRCondensedOff = #18;
     PRWide         = #14;          PRWideOff      = #20;
     PRPica         = #27#80;       PRElite        = #27#77;
     PRSuperScript  = #27#83#0;     PRSubScript    = #27#83#1;
     PRScriptOff    = #27#84;       PRInit         = #27#64;

     IconOff = 0; IconOn = 1; IconInvers = 2; MaxIcons = 100;
     MaxLines = 1500; MaxCharHigh = 50; MaxCharLength = 30;

Type ASCII = Record
         Ch : Char;
         Scan : Boolean
       End;

     TInputParam = Record
         InputProc : Procedure (Var P; Mode: Boolean);
         IEnd, IAllowed : String;
         ILen : Byte;
         IntMin, IntMax : Integer;
         RealMin, RealMax : Real;
         ConvertToCaps : Boolean;
         Free1, Free2 : Word;
       End;

     String2  = String[ 2];
     String4  = String[ 4];
     String8  = String[ 8];
     String11 = String[11];
     TIPName = String [15];

     PListBoxData = ^TListBoxData;
     TListBoxData = Array [1..255] Of Pointer;

     MouseMaskArray = Array [0..15] Of Word;
     MouseMaskRecord = Record
         HotSpotX, HotSpotY : Integer;
         ScreenMask, CursorMask : MouseMaskArray;
       End;
     MouseMaskPointer = ^MouseMaskRecord;
     TIconProc = Procedure;

     TPlayNotes = Record
         Len, High : Word
       End;

Var ToolsError, KbdEsc, CapsOnly, ComputerType, Feb29Exists,
    InputChanged, InGraphMode, IconCalled, ZSAvailable : Boolean;
    CursorStart, CursorEnd, CursorStartAlternate, CursorEndAlternate,
    StdColor, StdLightColor, StdBackground : Byte;
    MouseState, MouseFire, TextHigh, TextLength : Word;
    GraphDriver, GraphMode : Integer;
    InputEndChar, EditChar : Char;
    GetAllowed, GetScanAllowed, AdditionalInputEnd, InterruptEdit : String;
    GlobalIP : TInputParam;

Procedure ShowCursor;
Procedure HideCursor;
Procedure ShowAlternateCursor;
Procedure SetStdColor;
Procedure SetStdLightColor;
Procedure SetStdInvColor;
Procedure SetStdBlinkColor;
Procedure SetStdUnderlineColor;
Procedure SetIndividualAttrib (Attrib : Byte);
Function UpCaseGr (Ch : Char) : Char;
Procedure EnableIntensifyEGA;
Procedure EnableIntensifyHERC;
Procedure EnableBlinkingEGA;
Procedure EnableBlinkingHERC;
Procedure SetStdDosInOut;

Procedure Inkey (Var A : ASCII);
Procedure GetKey (Var A : ASCII);
Procedure ClearKbd;
Procedure Wait;
Function GetKeyboardState : Word;
Procedure SetNumLock (Modus : Boolean);
Procedure SetCapsLock (Modus : Boolean);
Procedure SetScrollLock (Modus : Boolean);

Function HexC (B : Byte) : Char;
Function HexB (B : Byte) : String2;
Function HexW (W : Word) : String4;
Function Bin (B : Byte) : String8;
Function BCD (B : Byte) : Byte;
Function Hex2Dez (H : String4) : Word;
Function Bin2Dez (H : String8) : Byte;
Function BCD2Dez (B : Byte) : Byte;
Function LoNib (B : Byte) : Byte;
Function HiNib (B : Byte) : Byte;
Function Pointer2String (P : Pointer) : String11;

Procedure CheckDate (Var Day, Month, Year : Word);
Procedure PackDate (Day, Month, Year : Word; Var P : Word);
Procedure UnPackDate (P : Word; Var Day, Month, Year : Word);
Procedure StrDate (P : Word; Var S : String);
Procedure ValDate (S : String; Var P : Word);
Function DayOfWeek (P : Word) : String;
Function Today : Word;

Procedure Play (Var Notes);

Procedure CharInput (Var P; Mode : Boolean);
Procedure StringInput (Var P; Mode : Boolean);
Procedure IntegerInput (Var P; Mode : Boolean);
Procedure RealInput (Var P; Mode : Boolean);
Procedure YesNoInput (Var P; Mode : Boolean);
Procedure DateInput (Var P; Mode : Boolean);
Procedure CurrentInput (Var P; Mode : Boolean);
Procedure PrintInput (Var Input);
Procedure DoInput (Var Input);

Procedure DefineInputParam (IP: TInputParam; Name : TIPName);
Procedure SetInputParam (Name : TIPName);
Procedure SetField (X, Y : Byte; Name : TIPName; Input : Pointer);
Procedure ClearField (X, Y : Byte);
Procedure RemoveAllFields;
Procedure PrepareEdit;
Procedure ConnectFields (X1, Y1, X2, Y2, Dirction1, Direction2 : Byte);
Procedure DeleteFieldConnection (X, Y, Direction: Byte);
Procedure SetEditPos (X, Y : Byte);
Procedure PrintEdit;
Procedure DoEdit;
Function GetEditX : Byte;
Function GetEditY : Byte;
Function GetEditHandle (X, Y : Byte) : Byte;

Procedure SaveScreen;
Procedure RestoreScreen;
Procedure DeleteScreen;
Procedure RemoveAllScreens;

Procedure HorizLine (X1, X2, Y : Byte; Data : String6);
Procedure VertLine (Y1, Y2, X : Byte; Data : String6);
Procedure Frame (X1, Y1, X2, Y2 : Byte; Data : String6);

Procedure ListBox (Data: PListBoxData; DataLen, ShowLen : Byte; Var Result : Byte);
Procedure ParseSwitch (Switch : String; Var Cmd : Char; Var Param : String);
Function IOResultMSG (Nr : Word) : String;
Function CheckSumError (CheckCode, Dummy : Byte) : Boolean;

Procedure EnterGraphMode;
Procedure LeaveGraphMode;

Procedure Assign43 (Var F : Text);
Procedure ClrEol;
Procedure ClrScr;
Procedure DelLine;
Procedure InsLine;
Procedure GotoXY (X, Y : Byte);
Procedure TextMode (Mode : Integer);
Function WhereX : Byte;
Function WhereY : Byte;
Procedure Window (X1, Y1, X2, Y2 : Byte);

Procedure InitMouse;
Procedure ShowMouse;
Procedure HideMouse;
Procedure ConditionalHideMouse (Left, Top, Right, Bottom : Integer);
Procedure SetMouseMask (Var Mask : MouseMaskRecord);
Procedure SetMousePosition (XPos, YPos : Integer);
Procedure GetMousePosition (Var XPos, YPos : Integer);
Procedure SetMouseWindow (Left, Top, Right, Bottom : Integer);
Procedure GetMouseMotion (Var Horizontal, Vertical : Integer);
Procedure SetMickeyPixelRatio (RatioX, RatioY : Integer);
Procedure SetDoubleSpeedThreshold (Threshold : Integer);
Function ButtonInput : Integer;
Function BothButtonsDown (Button: Byte): Boolean;
Function BothButtonsUp (Button: Byte): Boolean;
Function LeftButtonPressed (OldButton, NewButton : Byte) : Boolean;
Function LeftButtonReleased (OldButton, NewButton : Byte) : Boolean;
Function RightButtonPressed (OldButton, NewButton : Byte) : Boolean;
Function RightButtonReleased (OldButton, NewButton : Byte) : Boolean;
Function BothButtonsPressed (OldButton, NewButton : Byte) : Boolean;
Function BothButtonsReleased (OldButton, NewButton : Byte) : Boolean;

Procedure InitCrIC;
Procedure CreateIcon (XPos, YPos : Word; XGr, YGr : Byte; Name : TIPName);
Procedure DuplicateIcon (XPos, YPos : Word; Name : TIPName);
Procedure WriteIconField (FileName : String);

Procedure ReadIconField (FileName : String);
Function RegisterIconField (IconPointer : Pointer) : Integer;
Procedure SetIcon (Name : TIPName);
Procedure InvertIcon (Name : TIPName);
Procedure DeleteIcon (Name : TIPName);
Procedure RemoveAllIcons;
Function GetIconState (Name : TIPName) : Byte;
Procedure ChangeIconPosition (Name : TIPName; XNew, YNew : Word);
Procedure SetIconProc (Name : TIPName; IconProcedure : TIconProc);
Procedure DoIcon;

Procedure SelectZS (FileName : String);
Procedure SetZSStyle (Color, Spacing : Byte);
Procedure WriteZS (X, Y : Word; Output : String);
Procedure GetTextLength (Output : String);
Procedure EndUsingZS;
Procedure HighQualityHardcopy (MustHideMouse : Boolean);

Function CopyRight : String;

Implementation

Uses Crt, Dos, Graph, Printer;

Const DaySum   : Array [1..12] Of Word =
                   (0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334);
      MaxDays  : Array [1..12] Of Word =
                   (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
      YearDays : Array [0..3] Of Word =
                   (366, 365, 365, 365);
      Century = 19;
      MaxIconField = 65500;

Type TNotes = Array [1..32767] Of Word;
     PParamWithName = ^TParamWithName;
     TParamWithName = Record
         IP : TInputParam;
         Name : TIPName;
         Next : PParamWithName
       End;

     PField = ^TField;
     TField = Record
         X, Y : Byte;
         Name : TIPName;
         Input : Pointer;
         Up, Down, Left, Right, Next : PField
       End;

     TScreen = Array [0..1999] Of Word;
     PScreenRec = ^TScreenRec;
     TScreenRec = Record
         Screen : TScreen;
         WindMin, WindMax : Word;
         X, Y : Byte;
         TextAttr : Byte;
         CursorStart, CursorEnd : Byte;
         Last : PScreenRec
       End;
     PIconField = ^TIconField;
     TIconField = Array [1..MaxIconField] Of Byte;
     PZSData = ^TZSData;
     TZSData = Array [1..MaxLines] Of String [MaxCharLength];
     PCharData = ^TCharData;
     TCharData = Array [1..MaxCharHigh] Of String [MaxCharLength];

Var BIOSCursorStart   : Byte Absolute $0040:$0061;
    BIOSCursorEnd     : Byte Absolute $0040:$0060;
    BIOSKeyboardState : Byte Absolute $0040:$0017;
    MonoScreen  : TScreen Absolute $B000:$0000;
    ColorScreen : TScreen Absolute $B800:$0000;
    CopyRightRequested : Boolean;
    XCor, YCor, I : Byte;
    SaveExitProc : Pointer;
    LastColorInfo : Word;
    LastFillInfo : FillSettingsType;
    LastTextInfo : TextSettingsType;
    LastViewPortInfo : ViewPortType;
    FirstParam : PParamWithName;
    FirstField, EditField : PField;
    LastScreenRec : PScreenRec;
    IconField : PIconField;
    IconFieldSize : Word;
    IconMode : Array [0..MaxIcons] Of Byte;
    IconProc : Array [0..MaxIcons] Of TIconProc;
    IconFieldOnHeap : Boolean;
    CRICLastXGr, CRICLastYGr, CRICLastPosHi, CRICLastPosLo : Byte;
    CharHigh, CharLength, ZSColor, ZSSpace : Byte;
    LineSum : Word;
    ZSData : PZSData;
    CharData : PCharData;
    ZSMemAllocated : Boolean;

{$I SCREEN.INC}
{$I KBD.INC}
{$I HEX.INC}
{$I DATE.INC}
{$I SOUND.INC}
{$I INPUT.INC}
{$I EDIT.INC}
{$I SAVESCR.INC}
{$I FRAME.INC}
{$I LISTBOX.INC}
{$I MSG.INC}
{$I PWGRAPH.INC}
{$I MOUSE.INC}
{$I CRIC.INC}
{$I ICON.INC}
{$I HQHM.INC}
{$I PWTEXT.INC}

Function CopyRight : String;
  Begin
    CopyRight := 'Using Polarwolf Library';
    CopyRightRequested := True;
  End;

{$F+}
Procedure MyExitProc;
  Begin
    ExitProc := SaveExitProc;
    LeaveGraphMode
  End;
{$F-}

Begin
  ToolsError := False;
  CursorStart := BIOSCursorStart;
  CursorEnd := BIOSCursorEnd;
  CursorStartAlternate := 2;
  CursorEndAlternate := CursorEnd;
  StdColor := LightGray;
  StdLightColor := White;
  StdBackground := Black;
  ComputerType := XT;
  CapsOnly := False;
  Feb29Exists := False;
  For I := 32 To 254 Do AllVisibleChar := AllVisibleChar + Chr (I);
  Delete (AllVisibleChar, 96, 1);
  For I := 1 To 255 Do AllASCIICodes := AllASCIICodes + Chr (I);
  InGraphMode := False;
  DetectGraph (GraphDriver, GraphMode);
  SaveExitProc := ExitProc;
  ExitProc := @MyExitProc;
  LastViewPortInfo.Clip := False;
  XCor := 1;
  YCor := 1;
  InputChanged := False;
  GlobalIP.ConvertToCaps := False;
  FirstParam := Nil;
  FirstField := Nil;
  InterruptEdit := '';
  LastScreenRec := Nil;
  CopyRightRequested := False;
  IconFieldOnHeap := False;
  IconCalled := False;
  FillChar (IconMode, SizeOf (IconMode), #0);
  FillChar (IconProc, SizeOf (IconProc), #0);
  For I := 0 To MaxIcons Do IconProc [I] := Dummy;
  ZSAvailable := False;
  ZSMemAllocated := False;
End.
