{Polarwolf Library V2.2}

Procedure SelectZS (FileName : String);
  Var FileVar : Text;
  Begin
    If Not ZsMemAllocated Then
      Begin
        New (ZsData);
        New (CharData);
        ZSMemAllocated := True
      End;
    ZSAvailable := False;
    FillChar (ZSData^, SizeOf (ZSData^), #0);
    Assign (FileVar, FileName);
    Reset (FileVar);
    If IOResult > 0 Then Exit;
    LineSum := 1;
    Repeat
      ReadLn (FileVar, ZSData^ [LineSum]);
      If IOResult > 0 Then Exit;
      Inc (LineSum)
    Until Eof (FileVar);
    Dec (LineSum);
    Close (FileVar);
    ZSAvailable := True
  End;

Procedure SetZSStyle (Color, Spacing : Byte);
  Begin
    ZSColor := Color;
    ZSSpace := Spacing
  End;

Procedure FindChar (Ch : Char);
  Var I : Word;
  Begin
    ToolsError := True;
    CharLength := 0;
    CharHigh := 0;
    If Not ZSAvailable Then Exit;
    FillChar (CharData^, SizeOf (CharData^), #0);
    I := 0;
    Repeat
      Repeat
        Inc (I);
        If I = LineSum +1 Then Exit;
      Until  ZSData^ [I, 2] = ':'
    Until ZSData^ [I, 1] = Ch;
    CharHigh := Ord (ZSData^ [I, 3]) -47;
    Inc (I);
    While ZSData^ [I, 2] <> ':' Do
      Begin
        CharData^ [CharHigh] := ZSData^ [I];
        Inc (I);
        Inc (CharHigh)
      End;
    Dec (CharHigh);
    For I := 1 To CharHigh Do
      If Length (CharData^ [I]) > CharLength Then
        CharLength := Length (CharData^ [I]);
    If CharHigh > TextHigh Then TextHigh := CharHigh;
    ToolsError := False
  End;

Procedure DisplayChar (X, Y : Word);
  Var I, J : Byte;
  Begin
    If (ToolsError) Or (Not ZSAvailable) Then Exit;
    For I := 1 To CharHigh Do
      For J := 1 To Length (CharData^ [I]) Do
        If CharData^ [I, J] = '#' Then
          PutPixel (X + J -1, Y + I -1, ZSColor)
  End;

Procedure WriteZS (X, Y : Word; Output : String);
  Var I : Byte;
  Begin
    If Not ZSAvailable Then Exit;
    TextLength := 0;
    TextHigh := 0;
    For I := 1 To Length (Output) Do
      Begin
        FindChar (Output [I]);
        If ToolsError Then Exit;
        DisplayChar (X + TextLength, Y);
        TextLength := TextLength + CharLength + ZSSpace
      End;
    If TextLength > 0 Then TextLength := TextLength - ZSSpace
  End;

Procedure GetTextLength (Output : String);
  Var I : Byte;
  Begin
    If Not ZSAvailable Then Exit;
    TextLength := 0;
    TextHigh := 0;
    For I := 1 To Length (Output) Do
      Begin
        FindChar (Output [I]);
        If ToolsError Then Exit;
        TextLength := TextLength + CharLength + ZSSpace
      End;
    If TextLength > 0 Then TextLength := TextLength - ZSSpace;
  End;

Procedure EndUsingZS;
  Begin
    ZSAvailable := False;
    If Not ZSMemAllocated Then Exit;
    Dispose (ZsData);
    Dispose (CharData);
    ZSMemAllocated := False
  End;
