{Polarwolf Library V2.2}

Procedure DeleteScreen;
  Var H : PScreenRec;
  Begin
    If LastScreenRec = Nil Then Exit;
    H := LastScreenRec;
    LastScreenRec := LastScreenRec^.Last;
    Dispose (H)
  End;

Procedure SaveScreen;
  Var H : PScreenRec;
  Begin
    If LastScreenRec = Nil Then
      Begin
        New (LastScreenRec);
        LastScreenRec^.Last := Nil
      End
      Else Begin
        New (H);
        H^.Last := LastScreenRec;
        LastScreenRec := H
      End;
    If LastMode = 7 Then LastScreenRec^.Screen := MonoScreen
      Else LastScreenRec^.Screen := ColorScreen;
    LastScreenRec^.WindMin := WindMin;
    LastScreenRec^.WindMax := WindMax;
    LastScreenRec^.X := WhereX;
    LastScreenRec^.Y := WhereY;
    LastScreenRec^.TextAttr := TextAttr;
    LastScreenRec^.CursorStart :=  Mem [$0040:$0061];
    LastScreenRec^.CursorEnd := Mem [$0040:$0060]
  End;

Procedure RestoreScreen;
  Var Reg : Registers;
  Begin
    If LastScreenRec = Nil Then Exit;
    If LastMode = 7 Then MonoScreen := LastScreenRec^.Screen
      Else ColorScreen := LastScreenRec^.Screen;
    WindMin := LastScreenRec^.WindMin;
    WindMax := LastScreenRec^.WindMax;
    GotoXY (LastScreenRec^.X, LastScreenRec^.Y);
    TextAttr := LastScreenRec^.TextAttr;
    Reg.AH := $01;
    Reg.CH := LastScreenRec^.CursorStart;
    Reg.CL := LastScreenRec^.CursorEnd;
    Intr ($10, Reg);
    DeleteScreen
  End;

Procedure RemoveAllScreens;
  Begin
    While LastScreenRec <> Nil Do DeleteScreen
  End;
