{Polarwolf Library V2.2}

Procedure ShowCursor;
  Var Reg : Registers;
  Begin
    Reg.CH := CursorStart;
    Reg.CL := CursorEnd;
    Reg.AH := 1;
    Intr ($10, Reg)
  End;

Procedure HideCursor;
  Var Reg : Registers;
  Begin
    Reg.CH := CursorStart Or $20;
    Reg.CL := CursorEnd;
    Reg.AH := 1;
    Intr ($10, Reg)
  End;

Procedure ShowAlternateCursor;
  Var Reg : Registers;
  Begin
    Reg.CH := CursorStartAlternate;
    Reg.CL := CursorEndAlternate;
    Reg.AH := 1;
    Intr ($10, Reg)
  End;

Procedure SetStdColor;
  Begin
    TextBackground (StdBackGround);
    TextColor (StdColor);
    If (StdBackground And 8) > 0 Then TextAttr := TextAttr Or 128
  End;

Procedure SetStdLightColor;
  Begin
    TextBackground (StdBackground);
    TextColor (StdLightColor);
    If (StdBackground And 8) > 0 Then TextAttr := TextAttr Or 128
  End;

Procedure SetStdInvColor;
  Begin
    TextBackground (StdColor);
    TextColor (StdBackGround);
    If (StdColor And 8) > 0 Then TextAttr := TextAttr Or 128;
  End;

Procedure SetStdBlinkColor;
  Begin
    TextBackground (StdBackGround);
    TextColor (StdColor + Blink);
    If (StdBackground And 8) > 0 Then TextAttr := TextAttr Or 128
  End;

Procedure SetStdUnderlineColor;
  Begin
    TextBackground (StdBackGround);
    TextColor (Blue);
    If (StdBackground And 8) > 0 Then TextAttr := TextAttr Or 128
  End;

Procedure SetIndividualAttrib (Attrib : Byte);
  Begin
    If Odd (Attrib) Then SetStdInvColor Else SetStdColor;
    If (Attrib And Light) > 0 Then
      TextAttr := (TextAttr And 240) Or StdLightColor;
    If (Attrib And Blink) > 0  Then TextAttr := TextAttr Or Blink;
    If (Attrib And UnderLine) > 0 Then TextAttr := (TextAttr And 248) Or 1
  End;

Procedure EnableIntensifyEGA;
  Var Reg : Registers;
  Begin
    Reg.AH := $10;
    Reg.AL := $03;
    Reg.BL := $00;
    Intr ($10, Reg)
  End;

Procedure EnableIntensifyHERC;
  Begin
    Port [$3B8] := 8;
  End;

Procedure EnableBlinkingEGA;
  Var Reg : Registers;
  Begin
    Reg.AH := $10;
    Reg.AL := $03;
    Reg.BL := $01;
    Intr ($10, Reg)
  End;

Procedure EnableBlinkingHERC;
  Begin
    Port [$3B8] := 40
  End;

Procedure SetStdDosInOut;
   Begin
     Close (Output);
     Close (Input);
     Assign (Output, '');
     ReWrite (Output);
     Assign (Input, '');
     Reset (Input)
   End;
