Program UseCheck;

{$A+,B-,D-,E+,F-,G-,I-,L+,N-,O-,R+,S+,V+,X+}
{$M 16384,0,655360}

Uses Crt, PWLib;

Const CheckCode : Byte = 85;
      CheckSum  : Byte = 194;
      InitMSG = 'Polarwolf Library (C) Barbara Tikart  Polarwolf Hard & Software';

Var HelpMode, RunMode, ErrorMode : Boolean;
    MyCheckSum, MyCheckCode : Byte;
    Reloc : Word;
    OffsetCode, OffsetSum : LongInt;
    FileName : String;

Procedure DoHelpMode;
  Begin
    WriteLn ('Aufruf: USECHECK Filename [/R]');
    WriteLn ('Der Filename mu ohne Suffix .EXE angegeben werden.');
    WriteLn ('Auerdem wird eine MAP-File bentigt.');
    WriteLn ('Bei Angabe von /R startet USECHECK trotz Prfsummenfehler.');
    WriteLn;
    Halt
  End;

Procedure DoErrorMode;
  Begin
    WriteLn ('Fehler beim Aufruf von USECHECK');
    WriteLn ('Geben Sie USECHECK /? fr Hilfe ein.');
    Halt
  End;

Procedure DoCheckSumError;
  Begin
    WriteLn ('Prfsummenfehler - Verdacht auf Virenbefall');
    If RunMode Then Exit;
    WriteLn ('Programm angehalten.');
    Halt
  End;

Procedure AnalyseParam;
  Var I : Byte;
      Cmd : Char;
      Param : String;
  Begin
    FileName := '';
    RunMode := False;
    HelpMode := False;
    ErrorMode := False;
    For I := 1 To ParamCount Do
      Begin
        ParseSwitch (ParamStr (I), Cmd, Param);
        If Cmd = 'R' Then
          If Param = '' Then RunMode := True Else ErrorMode := True
          Else If Pos (Cmd, '?H') > 0 Then
            If Param = '' Then HelpMode := True Else ErrorMode := True
            Else If Cmd = ' ' Then
              If FileName = '' Then FileName := ParamStr (I)
                Else ErrorMode := True
              Else ErrorMode := True
      End;
    If HelpMode Then DoHelpMode;
    If (FileName = '') Or (Pos ('.', FileName) > 0) Or ErrorMode Then DoErrorMode;
    If CheckSumError (CheckCode, CheckSum) Then DoCheckSumError
  End;

Procedure ReadMAPFile;
  Var CodeFound, SumFound : Boolean;
      S, O : String4;
      Line : String;
      FileVar : Text;
  Label Gefunden;
  Begin
    CodeFound := False;
    SumFound := False;
    Assign (FileVar, FileName + '.MAP');
    Reset (FileVar);
    If IOResult > 0 Then
      Begin
        WriteLn ('MAP-File nicht gefunden!');
        WriteLn ('Programm angehalten.');
        Halt
      End;
    Repeat
      ReadLn (FileVar, Line);
      If InOutRes > 0 Then
        Begin
          WriteLn (IOResultMSG (IOResult), '!');
          Halt
        End;
      If Length (Line) > 10 Then
        Begin
          If (Copy (Line, Length (Line) -8, 255) = ' CHECKSUM') Or
             (Copy (Line, Length (Line) -8, 255) = Tab+'CHECKSUM') Then
            Begin
              S := Copy (Line, Pos (':', Line) -4, 4);
              O := Copy (Line, Pos (':', Line) +1, 4);
              OffsetSum := Hex2Dez (S);
              OffsetSum := OffsetSum * 16;
              If Not ToolsError Then OffsetSum := OffsetSum + Hex2Dez (O);
              SumFound := True;
            End;
          If (Copy (Line, Length (Line) -9, 255) = ' CHECKCODE') Or
             (Copy (Line, Length (Line) -9, 255) = Tab+'CHECKCODE') Then
            Begin
              S := Copy (Line, Pos (':', Line) -4, 4);
              O := Copy (Line, Pos (':', Line) +1, 4);
              OffsetCode := Hex2Dez (S);
              OffsetCode := OffsetCode * 16;
              If Not ToolsError Then OffsetCode := OffsetCode + Hex2Dez (O);
              CodeFound := True;
            End;
          If ToolsError Then
            Begin
              WriteLn ('Fehler beim Interpretieren der MAP-Datei!');
              WriteLn ('Programm angehalten.');
              Halt
            End;
          If SumFound And CodeFound Then Goto Gefunden;
        End;
    Until EOF (FileVar);
    WriteLn ('Variable CHECKSUM oder CHECKCODE nicht gefunden!');
    Halt;
Gefunden:
    Close (FileVar);
  End;

Procedure ReadEXEFile;
  Var Count, B : Byte;
      W : Word;
      Position : LongInt;
      FileVar : File Of Byte;
  Label Fehler;
  Begin
    Reloc := 0;
    Position := 0;
    Count := 0;
    MyCheckSum := 0;
    Assign (FileVar, FileName + '.EXE');
    Reset (FileVar);
    If IOResult > 0 Then
      Begin
        WriteLn ('EXE-Datei nicht gefunden');
        WriteLn ('Programm angehalten.');
        Halt
      End;
    Seek (FileVar, 8);
    If InOutRes > 0 Then Goto Fehler;
    Read (FileVar, B);
    If InOutRes > 0 Then Goto Fehler;
    Reloc := B;
    Read (FileVar, B);
    If InOutRes > 0 Then Goto Fehler;
    Reloc := Reloc + 256 * B;
    Seek (FileVar, OffsetCode + Reloc * 16);
    If InOutRes > 0 Then Goto Fehler;
    Read (FileVar, MyCheckCode);
    If InOutRes > 0 Then Goto Fehler;
    Seek (FileVar, 0);
    If InOutRes > 0 Then Goto Fehler;
    While Not EOF (FileVar) Do
      Begin
        Read (FileVar, B);
        If InOutRes > 0 Then Goto Fehler;
        If Position <> OffsetSum + Reloc * 16 Then
          Begin
            W := B + Count;
            W := W XOr MyCheckCode;
            MyCheckSum := Lo (MyCheckSum + W)
          End;
        Inc (Count);
        Inc (Position)
      End;
    Close (FileVar);
    If InOutRes > 0 Then Goto Fehler;
    If Position >= OffsetSum + Reloc * 16 Then Exit;
Fehler: If InOutRes > 0 Then WriteLn (IOResultMSG (IOResult), '!')
      Else WriteLn ('Fehler beim Lesen der EXE-Datei!');
    WriteLn ('Programm angehalten.');
    Halt
  End;

Begin
  CheckBreak := True;
  SetStdDosInOut;
  WriteLn (InitMSG);
  AnalyseParam;
  ReadMAPFile;
  ReadEXEFile;
  MyCheckSum := Lo (256 - MyCheckSum);
  MyCheckSum := MyCheckSum XOr MyCheckCode;
  MyCheckSum := Lo ((256 + MyCheckSum) - Lo (OffsetSum + Reloc * 16));
  WriteLn ('Das Programm hat die Prfsumme: ', MyCheckSum)
End.
